<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__ipc" kind="group">
    <compoundname>group_ipc</compoundname>
    <title>IPC          (Inter Process Communication)</title>
    <innergroup refid="group__group__ipc__drv">IPC driver layer (IPC_DRV)</innergroup>
    <innergroup refid="group__group__ipc__sema">IPC semaphores layer (IPC_SEMA)</innergroup>
    <innergroup refid="group__group__ipc__pipe">IPC pipes layer (IPC_PIPE)</innergroup>
    <briefdescription>
<para>The inter-processor communication (IPC) driver provides a safe and reliable method to transfer data between CPUs. </para>    </briefdescription>
    <detaileddescription>
<para>Hardware locking ensures that only one device can acquire and transfer data at a time so no data is lost or overwritten by asynchronous processes or CPUs.</para><para>Include either cy_ipc_pipe.h or cy_ipc_sema.h. Alternatively include cy_pdl.h to get access to all functions and declarations in the PDL.</para><para>There are three parts to the API:<itemizedlist>
<listitem><para>Driver-level (DRV) API - used internally by Semaphore and Pipe levels</para></listitem><listitem><para>Pipe-level (PIPE) API - establishes a communication channel between processors</para></listitem><listitem><para>Semaphore-level (SEMA) API - enables users to set and clear flags to synchronize operations.</para></listitem></itemizedlist>
</para><para>Firmware does not need to use the DRV API. It can implement IPC functionality entirely with the PIPE and SEMA APIs.</para>
<para><heading level="1">Background</heading></para>
<para>IPC is implemented in hardware as a collection of individual communication channels, each with a set of 32-bit registers. The IPC design implements a set of interrupts that enable each processor to notify the other that data is available, or has been processed. There is also a locking mechanism that allows only one CPU to gain access at a time.</para><para>The Driver-level API manages each channel's registers to implement IPC functionality. For information on the IPC registers, see the IPC chapter of the Technical Reference Manual (TRM).</para><para>At the hardware level, communication is a five-step process.<orderedlist>
<listitem><para>The sending processor acquires a channel</para></listitem><listitem><para>It puts data into the channel</para></listitem><listitem><para>The sender generates a notify event (interrupt)</para></listitem><listitem><para>The receiving processor identifies the sender and retrieves the data</para></listitem><listitem><para>The receiving processor generates a release event (interrupt)</para></listitem></orderedlist>
</para><para><image name="ipc_driver.png" type="html" />
</para><para>These transactions are handled transparently by the DRV-level API. Use the PIPE and SEMA layers of the API to implement communication in your application. The data transferred is limited to a single 32-bit value. As implemented by the PIPE API, that value is a pointer to a data structure of arbitrary size and complexity.</para>

<para><heading level="1">Overview</heading></para>
<para>The Pipe is the key element in the PDL design. A pipe is typically a full-duplex communication channel between CPU cores. A pipe allows a single conduit to transfer messages or data to and from multiple processes or CPUs.</para><para>A pipe has two endpoints, one on each core. Each endpoint contains a dedicated IPC channel and an interrupt. IPC channels 0-7(8 for the CYB064XX devices) and IPC interrupts 0-7 are reserved for system use.</para><para>The pipe also contains the number of clients it supports, and for each client a callback function. So the pipe can service a number of clients, each with a separate callback function, on either endpoint. The number of clients a pipe supports is the sum of each endpoint's clients.</para><para>This design enables any number of processes on the sending core to put arbitrary data into a single pipe. The first element of that data is the client ID of the client that should handle the data.</para><para>An interrupt notifies the receiving core that data is available. The receiving core parses the data to identify the client, and then dispatches the event to the appropriate client via the client callback function. An interrupt notifies the sending core that the receiver is finished. In this way a single pipe can manage arbitrary data transfers between cores with data flowing in either direction.</para><para><image name="ipc_ints.png" type="html" />
</para><para>The application can use semaphores to control access to shared resources, as required by the application's logic.</para><para>The PDL provides specific files that set up default IPC functionality. They are system_psoc6.h, system_psoc6_cm0plus.c and system_psoc6_cm4.c. You can modify these files based on the requirements of your design. If you use PSoC Creator as a development environment, it will not overwrite your changes when you generate the application or build your code.</para>

<para><heading level="1">PIPE layer</heading></para>
<para>A pipe is a communication channel between two endpoints. PSoC 6 devices support 16 IPC channels, and 16 IPC interrupts, each numbered 0-15. IPC Channels 0-7 and IPC interrupts 0-7 are reserved for system use. Channels 8-15 and interrupts 8-15 are available for application use.</para><para>A full duplex pipe uses two IPC channels, one per endpoint. Each endpoint specifies all the information required to process a message (either sent or received). Each endpoint is configured to use an IPC channel, and an IPC interrupt. Common practice is to use the interrupt with the same number as the IPC channel. However, IPC Interrupts are not directly associated with the IPC channels, so any channel can use any interrupt. Any IPC channel can trigger 0, 1 or all the IPC interrupts at once, depending on the Notify or Release masks used.</para><para>It is also possible to set up a one-directional pipe, using a single IPC channel. In this design one processor is always the sender, and the other is always the receiver. However, there are still two endpoints.</para><para>A pipe supports an arbitrary number of clients with an array of callback functions, one per client. The client ID is the index number into the array for the client. After a pipe is configured and initialized, the application calls <ref kindref="member" refid="group__group__ipc__pipe__functions_1ga2c998e0f6927eb99ac850daa4a2d5acc">Cy_IPC_Pipe_RegisterCallback()</ref> once per client to register each client's callback function. Multiple clients can use the same callback function. The endpoints in a pipe share the callback array.</para><para>Use <ref kindref="member" refid="group__group__ipc__pipe__functions_1ga2a3f9b25f2227abe8cf66880c1d5d5a5">Cy_IPC_Pipe_SendMessage()</ref> to send data. You specify both the "to" and "from" endpoints, and a callback function to be used when the data transfer is complete. The data is a 32-bit void pointer. The data pointed to is arbitrary, and can be an array, a structure, or a location in memory. The only limitation is that the first element of the data must be a 32-bit unsigned word containing a client ID number. The ID number is the index into the callback array.</para><para>When a message is sent, the receiving endpoint's interrupt handler is called. The ISR can perform any task required by the design. However, as part of its function it calls <ref kindref="member" refid="group__group__ipc__pipe__functions_1ga57550447f7bca5f2990868bac69f41dc">Cy_IPC_Pipe_ExecCallback</ref>. This function retrieves the client ID from the data and calls the associated callback function. The user-supplied callback function handles the data in whatever way is appropriate based on the application logic.</para><para>After the callback function is returned by the receiver, it invokes the release callback function defined by the sender of the message.</para>

<para><heading level="1">SEMA Layer</heading></para>
<para>A semaphore is a flag the application uses to control access to a shared resource. The SEMA-level API uses an IPC channel to implement semaphores. Startup code sets up a default semaphore system. The default system creates an array of 128 semaphores (four 32-bit values). Semaphores 0-15 are reserved for system use. See Configuration Considerations - SEMA.</para><para>Functions are available to initialize the semaphore system, to set or clear a semaphore, or to get the semaphore's current status. Application logic uses SEMA functions to relate a particular semaphore to a particular shared resource, and set, clear, or check the flag when accessing the shared resource.</para>

<para><heading level="1">Configuration Considerations - CYPIPE</heading></para>
<para>There are none. The startup files set up the required CYPIPE for system use. Do not modify the CYPIPE. It uses IPC channels 5 and 6 to implement full duplex communication between cores. See System Interrupt (SysInt) for background.</para><para>To create your own pipe (<bold>USRPIPE</bold>) you should edit startup files and take 4 steps:<orderedlist>
<listitem><para>Define a pipe callbacks processing interrupt handler (similar to <bold>Cy_SysIpcPipeIsrCm0</bold> or <bold>Cy_SysIpcPipeIsrCm4</bold>)</para></listitem><listitem><para>Define a callbacks array (similar to <bold>systemIpcPipeSysCbArray</bold>)</para></listitem><listitem><para>Define your pipe configuration with a <ref kindref="compound" refid="structcy__stc__ipc__pipe__config__t">cy_stc_ipc_pipe_config_t</ref> type structure (similar to <bold>systemIpcPipeConfigCm0</bold> and <bold>systemIpcPipeConfigCm4</bold>)</para></listitem><listitem><para>Call <ref kindref="member" refid="group__group__ipc__pipe__functions_1gafb7fa479327e6d7c282c262bc1dc6c8c">Cy_IPC_Pipe_Init()</ref> from each core to initialize your pipe (similar to call in the <bold>SystemInit</bold>)</para></listitem></orderedlist>
</para>

<para><heading level="1">Configuration Considerations - SEMA</heading></para>
<para>Startup code calls <ref kindref="member" refid="group__group__ipc__sema__functions_1ga1cbc3b147c650c8716de10a1ee8423bd">Cy_IPC_Sema_Init()</ref> with default values to set up semaphore functionality. By default the semaphore system uses IPC channel 4, and creates 128 semaphores. Do <bold>not</bold> change the IPC channel. You can change the number of semaphores.</para><para>To change the number of semaphores, modify this line of code in system_psoc6.h.</para><para><programlisting><codeline><highlight class="normal">#define<sp />CY_IPC_SEMA_COUNT<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(uint32_t)(128u)</highlight></codeline>
</programlisting></para><para>Startup also declares array ipcSemaArray to hold the semaphore flags based on the size defined for this symbol. Use increments of 32. You must have at least 32 semaphores. Semaphores 0-15 are reserved for system use. Your application can use semaphores greater than 15.</para>

<para><heading level="1">More Information</heading></para>
<para>If the default startup file is not used, or <ref kindref="member" refid="group__group__system__config__system__functions_1ga93f514700ccf00d08dbdcff7f1224eb2">SystemInit()</ref> is not called in your project, call the following three functions prior to executing any flash or EmEEPROM write or erase operation:<orderedlist>
<listitem><para><ref kindref="member" refid="group__group__ipc__sema__functions_1ga1cbc3b147c650c8716de10a1ee8423bd">Cy_IPC_Sema_Init()</ref></para></listitem><listitem><para><ref kindref="member" refid="group__group__ipc__pipe__functions_1ga7a1c8f1e92e74f27856ef2b7ac09c640">Cy_IPC_Pipe_Config()</ref></para></listitem><listitem><para><ref kindref="member" refid="group__group__ipc__pipe__functions_1gafb7fa479327e6d7c282c262bc1dc6c8c">Cy_IPC_Pipe_Init()</ref></para></listitem><listitem><para><ref kindref="member" refid="group__group__flash__functions_1gaf1b44a029169a1baa08e211bff714a19">Cy_Flash_Init()</ref></para></listitem></orderedlist>
</para><para>See the technical reference manual(TRM) for more information on the IPC.</para>

<para><heading level="1">MISRA-C Compliance</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;MISRA Rule &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Class (Required/Advisory) &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Description &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Description of Deviation(s)  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;10.3 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The value of a complex expression of integer type shall be cast only to a type of the same signedness that is no wider than the underlying type of the expression. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The cast from integer to enumeration value is used to calculate the interrupt vector source from the integer number of the IPC interrupt structure, so there is no way to avoid this cast.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;11.4 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A cast should not be performed between a pointer to the void to a pointer to the object type. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The cast from the void to pointer and vice versa is used to transmit data via the &lt;a href="group__group__ipc.html#"&gt;IPC (Inter Process Communication)&lt;/a&gt; channel by exchanging the pointer. We exchange only one pointer, so there is no way to avoid this cast.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">Changelog</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Version&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Changes&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Reason for Change &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.40.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Minor documentation updates. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation enhancement.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.40 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Moved cy_semaData structure to the RAM section called ".cy_sharedmem". &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Support Secure Boot devices.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="3"&gt;&lt;p&gt;1.30 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Flattened the organization of the driver source code into the single source directory and the single include directory. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Driver library directory-structure simplification.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Moved the Cy_IPC_SystemSemaInit(), Cy_IPC_SystemPipeInit() functions implementation from IPC to Startup, removed cy_ipc_config.c and cy_ipc_config.h files. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Changed IPC driver configuration method from compile time to run time.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added register access layer. Use register access macros instead of direct register access using dereferenced pointers. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Makes register access device-independent, so that the PDL does not need to be recompiled for each supported part number.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.20 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added &lt;a href="group__group__ipc__pipe__functions.html#group__group__ipc__pipe__functions_1ga7cff3c4286e6e23519d9925d394ac218"&gt;Cy_IPC_Pipe_ExecuteCallback&lt;/a&gt; function. Updated documentation about user pipe initialization.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Interface improvement, documentation update  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.10.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated description of the &lt;a href="group__group__ipc__pipe__functions.html#group__group__ipc__pipe__functions_1gafb7fa479327e6d7c282c262bc1dc6c8c"&gt;Cy_IPC_Pipe_Init&lt;/a&gt;, &lt;a href="group__group__ipc__pipe__functions.html#group__group__ipc__pipe__functions_1gad9865b8577da5a3d580bb6473f9b0912"&gt;Cy_IPC_Pipe_EndpointInit&lt;/a&gt;, &lt;a href="group__group__ipc__sema__functions.html#group__group__ipc__sema__functions_1ga455867cd3b817d61d355f0407221a9a9"&gt;Cy_IPC_Sema_Set&lt;/a&gt; functions. Added / updated code snippets.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation update and clarification  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.10 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added support for more IPC structures &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;New device support  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Initial version &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>